# -*- coding: utf-8 -*- 
# @Time    : 04/03/2024 
# @Author  : nzooherd 
# @File    : user.py 
# @Software: Visual Studio Code

import functools
from typing import Any, Callable, Coroutine

from service.user_service import UserService

class UserAspect:

    def __init__(self) -> None:
        self.user_service = UserService()

    def __call__(self, handler: Callable[[Any, Any], Coroutine]):

        @functools.wraps(handler)
        async def wrapper(controller: object, update: Any):
            self.user_service.init_user_context(update)
            await handler(controller, update)
        return wrapper